(*
 Sia GAB l’insieme dei grafi orientati con nodi etichettai su A ed archi etichet-
 tati su B, con le seguenti operazioni:
	mkG: crea un grafo vuoto GAB, per dati tipi A e B;
	addN ln g: genera un grafo g’ di GAB che estende g con i nodi della lista ln 
			   non gi\`a contenuti in g. 
	addE le g: genera un grafo g’ di GAB che estende g con gli archi della lista 
			   le non gi\`a contenuti in g. Pu\`o solevare eccezioni.
	removeN n g: genera un grafo g' che differisce da g per la rimozione del nodo 
				 n e di tutto gli archi entranti ed uscenti da n. Pu\`o sol. eccez.
	removeE e g: genera un grafo g' che differisce da g per la rimozione del solo 
	             arco e. Pu\'o sollevare eccezioni.
	isNin n g: calcola vero sse n \`e un nodo di g
	isEin e g: calcola vero sse e \`e un arco di g
	nodes g: calcola la lista di tutti i nodi di g
	outN n g:  calcola la lista dei nodi uscenti da n in g. Pu\`o sollevare eccez.  
 Si definisca in OCaml un modulo signature, GRAPH, per il tipo astratto ('a,'b)gr-
 aph che esprime grafi GAB IMMUTABE con le operazioni descritte sopra.
 (a) Si mostri intestazione dell’assunta classe GRAPH, segnatura, modificatori e 
     valori calcolati dei metodi
 (b) Si mostri un modulo Graph che fornisca una ADT
 Allo scopo si assumano dati i tipi:
 		'a node per nodi etichettati su 'a;
 		('a,'b) edge per archi etichettati su 'b tra nodi di tipo 'a node.
 *)

(* questi tipi sono pubblici per semplicit\`a *) 
type 'a node = N of 'a
type ('a,'b) edge = E of 'a node * 'a node * 'b


(* questo \`e il tipo astratto richiesto *)
module type GRAPH =
 sig type ('a,'b) graph 
  val mkG: 'a -> 'b -> ('a,'b) graph
  val addN: 'a node list -> ('a,'b) graph -> ('a,'b) graph
  val addE: ('a,'b) edge list -> ('a,'b) graph -> ('a,'b) graph
  val removeN: 'a node -> ('a,'b) graph -> ('a,'b) graph
  val removeE: ('a,'b) edge -> ('a,'b) graph -> ('a,'b) graph
  val isNin: 'a node -> ('a,'b) graph -> bool
  val isEin: ('a,'b) edge -> ('a,'b) graph -> bool
  val nodes: ('a, 'b) graph -> 'a node list
  val outN: 'a node -> ('a,'b) graph -> 'a node list
  exception InvalidArgException of string
end;;
 
module Graph =
 (struct
  type ('a,'b) outer = C of 'a node * ('a,'b) edge list
  type ('a,'b) graph = G of 'a * 'b * ('a,'b) outer list
  (*
  	AF(c) = <{},{}> iff (c = G(_,_,[]))
  	AF(c) = <{n1,...,nk},{e1,...,eh}> iff ((c = G(_,_,otr)) && 
  			                               forall i\in[1..k], (node n1 otr) &&
  			                               forall i\in[1..h], (edge ei otr))
  	I(c) = ...
  	
  	where:
  	node x otr = let g (C(n,_)) = n in List.mem x (List.map g otr) 
  	edge x otr = let g (C(_,el)) = el in List.mem x (flatten(List.map g otr))  	  	
  *)
  
(* funzioni ausiliarie:inizio *)
let mkG ...
let addN ...
let addE ...




(* operazioni pubbliche:inizio *)



end:GRAPH);;
